<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.14" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__hal__i2c" kind="group">
    <compoundname>group_hal_i2c</compoundname>
    <title>I2C (Inter-Integrated Circuit)</title>
    <innerclass prot="public" refid="structcyhal__i2c__cfg__t">cyhal_i2c_cfg_t</innerclass>
    <innergroup refid="group__group__hal__results__i2c">I2C HAL Results</innergroup>
      <sectiondef kind="enum">
      <memberdef id="group__group__hal__i2c_1gaaba7daccaa3861c32a4b0284e8194a79" kind="enum" prot="public" static="no" strong="no">
        <type />
        <name>cyhal_i2c_event_t</name>
        <enumvalue id="group__group__hal__i2c_1ggaaba7daccaa3861c32a4b0284e8194a79a80d8eb3997f062277769a958ff0b74bd" prot="public">
          <name>CYHAL_I2C_EVENT_NONE</name>
          <initializer>= 0</initializer>
          <briefdescription>
<para>No event. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__i2c_1ggaaba7daccaa3861c32a4b0284e8194a79a08f85e87b6ee6690714adc58a8b4a426" prot="public">
          <name>CYHAL_I2C_SLAVE_READ_EVENT</name>
          <initializer>= 1 &lt;&lt; 1</initializer>
          <briefdescription>
<para>Indicates that the slave was addressed and the master wants to read data. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__i2c_1ggaaba7daccaa3861c32a4b0284e8194a79af9d18fd8a6768ca60dbc475d3a08f13a" prot="public">
          <name>CYHAL_I2C_SLAVE_WRITE_EVENT</name>
          <initializer>= 1 &lt;&lt; 2</initializer>
          <briefdescription>
<para>Indicates that the slave was addressed and the master wants to write data. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__i2c_1ggaaba7daccaa3861c32a4b0284e8194a79ad4a472c6da6121e533e871960a57d8b3" prot="public">
          <name>CYHAL_I2C_SLAVE_RD_IN_FIFO_EVENT</name>
          <initializer>= 1 &lt;&lt; 3</initializer>
          <briefdescription>
<para>All slave data from the configured Read buffer has been loaded into the TX FIFO. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__i2c_1ggaaba7daccaa3861c32a4b0284e8194a79af1d3cec9a44b25d6d1434b9d21457cf2" prot="public">
          <name>CYHAL_I2C_SLAVE_RD_BUF_EMPTY_EVENT</name>
          <initializer>= 1 &lt;&lt; 4</initializer>
          <briefdescription>
<para>The master has read all data out of the configured Read buffer. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__i2c_1ggaaba7daccaa3861c32a4b0284e8194a79af3743e0bae6fc016ae15741d69b765e8" prot="public">
          <name>CYHAL_I2C_SLAVE_RD_CMPLT_EVENT</name>
          <initializer>= 1 &lt;&lt; 5</initializer>
          <briefdescription>
<para>Indicates the master completed reading from the slave (set by the master NAK or Stop) </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__i2c_1ggaaba7daccaa3861c32a4b0284e8194a79aed43708fe51a3270699f80f21dde4bac" prot="public">
          <name>CYHAL_I2C_SLAVE_WR_CMPLT_EVENT</name>
          <initializer>= 1 &lt;&lt; 6</initializer>
          <briefdescription>
<para>Indicates the master completed writing to the slave (set by the master Stop or Restart) </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__i2c_1ggaaba7daccaa3861c32a4b0284e8194a79aba7cb8e07c8f47bd41a74af1373c7d04" prot="public">
          <name>CYHAL_I2C_SLAVE_ERR_EVENT</name>
          <initializer>= 1 &lt;&lt; 7</initializer>
          <briefdescription>
<para>Indicates the I2C hardware detected an error. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__i2c_1ggaaba7daccaa3861c32a4b0284e8194a79a9fd6214feece0581282414f326fc3ef4" prot="public">
          <name>CYHAL_I2C_MASTER_WR_IN_FIFO_EVENT</name>
          <initializer>= 1 &lt;&lt; 17</initializer>
          <briefdescription>
<para>All data specified by cyhal_i2c_master_transfer_async has been loaded into the TX FIFO. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__i2c_1ggaaba7daccaa3861c32a4b0284e8194a79a0365270204869bfe80a2015258c979e1" prot="public">
          <name>CYHAL_I2C_MASTER_WR_CMPLT_EVENT</name>
          <initializer>= 1 &lt;&lt; 18</initializer>
          <briefdescription>
<para>The master write started by cyhal_i2c_master_transfer_async is complete. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__i2c_1ggaaba7daccaa3861c32a4b0284e8194a79ac5b8050af1c08b0d00a21539c5286435" prot="public">
          <name>CYHAL_I2C_MASTER_RD_CMPLT_EVENT</name>
          <initializer>= 1 &lt;&lt; 19</initializer>
          <briefdescription>
<para>The master read started by cyhal_i2c_master_transfer_async is complete. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__i2c_1ggaaba7daccaa3861c32a4b0284e8194a79a4bda40d48c2d7ca1c7556367b532920f" prot="public">
          <name>CYHAL_I2C_MASTER_ERR_EVENT</name>
          <initializer>= 1 &lt;&lt; 20</initializer>
          <briefdescription>
<para>Indicates the I2C hardware has detected an error. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <briefdescription>
<para><bold>cyhal_i2c_event_t: </bold><linebreak />Enum to enable/disable/report interrupt cause flags.</para></briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="150" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2c.h" bodystart="136" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2c.h" line="137" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="typedef">
      <memberdef id="group__group__hal__i2c_1ga67df812388aae9fcc3b3b1986dab7a09" kind="typedef" prot="public" static="no">
        <type>void(*</type>
        <definition>typedef void(* cyhal_i2c_event_callback_t) (void *callback_arg, cyhal_i2c_event_t event)</definition>
        <argsstring>)(void *callback_arg, cyhal_i2c_event_t event)</argsstring>
        <name>cyhal_i2c_event_callback_t</name>
        <briefdescription>
<para>Handler for I2C events. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2c.h" bodystart="154" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2c.h" line="154" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__hal__i2c_1gac2885a21905af9d1d48aae34a6032a61" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_i2c_init</definition>
        <argsstring>(cyhal_i2c_t *obj, cyhal_gpio_t sda, cyhal_gpio_t scl, const cyhal_clock_t *clk)</argsstring>
        <name>cyhal_i2c_init</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2c__t">cyhal_i2c_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga707195ce0627016bf371643bdd9caa51">cyhal_gpio_t</ref></type>
          <declname>sda</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga707195ce0627016bf371643bdd9caa51">cyhal_gpio_t</ref></type>
          <declname>scl</declname>
        </param>
        <param>
          <type>const <ref kindref="compound" refid="structcyhal__clock__t">cyhal_clock_t</ref> *</type>
          <declname>clk</declname>
        </param>
        <briefdescription>
<para>Initialize the I2C peripheral, and configures its specified pins. </para>        </briefdescription>
        <detaileddescription>
<para>By default it is configured as a Master with a bus frequency = CYHAL_I2C_MASTER_DEFAULT_FREQ. Use <ref kindref="member" refid="group__group__hal__i2c_1ga37a35abcb9bf2d0ecf2a52b2fa5bce64">cyhal_i2c_configure()</ref> to change the default behavior.<linebreak />
 NOTE: Master/Slave specific functions only work when the block is configured to be in that mode.<linebreak />
 See <ref kindref="member" refid="group__group__hal__i2c_1subsection_i2c_snippet_1">Snippet 1: I2C Initialization and Configuration</ref></para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="out">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to an I2C object. The caller must allocate the memory for this object but the init function will initialize its contents. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">sda</parametername>
</parameternamelist>
<parameterdescription>
<para>The sda pin </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">scl</parametername>
</parameternamelist>
<parameterdescription>
<para>The scl pin </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">clk</parametername>
</parameternamelist>
<parameterdescription>
<para>The clock to use can be shared, if not provided a new clock will be allocated </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the init request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="250" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_i2c.c" bodystart="151" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2c.h" line="182" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2c_1ga3335fac7601fb3a6e4210d24e55cca61" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_i2c_free</definition>
        <argsstring>(cyhal_i2c_t *obj)</argsstring>
        <name>cyhal_i2c_free</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2c__t">cyhal_i2c_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Deinitialize the i2c object. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="inout">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The i2c object </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="275" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_i2c.c" bodystart="252" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2c.h" line="188" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2c_1ga37a35abcb9bf2d0ecf2a52b2fa5bce64" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_i2c_configure</definition>
        <argsstring>(cyhal_i2c_t *obj, const cyhal_i2c_cfg_t *cfg)</argsstring>
        <name>cyhal_i2c_configure</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2c__t">cyhal_i2c_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>const <ref kindref="compound" refid="structcyhal__i2c__cfg__t">cyhal_i2c_cfg_t</ref> *</type>
          <declname>cfg</declname>
        </param>
        <briefdescription>
<para>Configure the I2C block. </para>        </briefdescription>
        <detaileddescription>
<para>NOTE: Master/Slave specific functions only work when the block is configured to be in that mode.<linebreak />
 See <ref kindref="member" refid="group__group__hal__i2c_1subsection_i2c_snippet_1">Snippet 1: I2C Initialization and Configuration</ref></para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2C object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">cfg</parametername>
</parameternamelist>
<parameterdescription>
<para>Configuration settings to apply </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the configure request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="310" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_i2c.c" bodystart="277" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2c.h" line="200" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2c_1gaf100c21cd95409c70e1ba0463c23e3f8" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_i2c_master_write</definition>
        <argsstring>(cyhal_i2c_t *obj, uint16_t dev_addr, const uint8_t *data, uint16_t size, uint32_t timeout, bool send_stop)</argsstring>
        <name>cyhal_i2c_master_write</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2c__t">cyhal_i2c_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>uint16_t</type>
          <declname>dev_addr</declname>
        </param>
        <param>
          <type>const uint8_t *</type>
          <declname>data</declname>
        </param>
        <param>
          <type>uint16_t</type>
          <declname>size</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>timeout</declname>
        </param>
        <param>
          <type>bool</type>
          <declname>send_stop</declname>
        </param>
        <briefdescription>
<para>I2C master blocking write. </para>        </briefdescription>
        <detaileddescription>
<para>This will write size bytes of data from the buffer pointed to by data. It will not return until either all of the data has been written, or the timeout has elapsed.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2C object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">dev_addr</parametername>
</parameternamelist>
<parameterdescription>
<para>device address (7-bit) </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">data</parametername>
</parameternamelist>
<parameterdescription>
<para>I2C send data </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">size</parametername>
</parameternamelist>
<parameterdescription>
<para>I2C send data size </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">timeout</parametername>
</parameternamelist>
<parameterdescription>
<para>timeout in millisecond, set this value to 0 if you want to wait forever </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">send_stop</parametername>
</parameternamelist>
<parameterdescription>
<para>whether the stop should be send, used to support repeat start conditions</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the master_write request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="343" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_i2c.c" bodystart="312" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2c.h" line="218" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2c_1ga0652a883293c83ebd0612fddbd8ff64d" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_i2c_master_read</definition>
        <argsstring>(cyhal_i2c_t *obj, uint16_t dev_addr, uint8_t *data, uint16_t size, uint32_t timeout, bool send_stop)</argsstring>
        <name>cyhal_i2c_master_read</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2c__t">cyhal_i2c_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>uint16_t</type>
          <declname>dev_addr</declname>
        </param>
        <param>
          <type>uint8_t *</type>
          <declname>data</declname>
        </param>
        <param>
          <type>uint16_t</type>
          <declname>size</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>timeout</declname>
        </param>
        <param>
          <type>bool</type>
          <declname>send_stop</declname>
        </param>
        <briefdescription>
<para>I2C master blocking read. </para>        </briefdescription>
        <detaileddescription>
<para>This will read size bytes of data into the buffer pointed to by data. It will not return until either all of the data has been read, or the timeout has elapsed.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2C object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">dev_addr</parametername>
</parameternamelist>
<parameterdescription>
<para>device address (7-bit) </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">data</parametername>
</parameternamelist>
<parameterdescription>
<para>I2C receive data </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">size</parametername>
</parameternamelist>
<parameterdescription>
<para>I2C receive data size </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">timeout</parametername>
</parameternamelist>
<parameterdescription>
<para>timeout in millisecond, set this value to 0 if you want to wait forever </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">send_stop</parametername>
</parameternamelist>
<parameterdescription>
<para>whether the stop should be send, used to support repeat start conditions</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the master_read request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="381" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_i2c.c" bodystart="345" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2c.h" line="235" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2c_1ga2642bdcfecb06786c438801bbc6ed844" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_i2c_slave_config_write_buffer</definition>
        <argsstring>(cyhal_i2c_t *obj, const uint8_t *data, uint16_t size)</argsstring>
        <name>cyhal_i2c_slave_config_write_buffer</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2c__t">cyhal_i2c_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>const uint8_t *</type>
          <declname>data</declname>
        </param>
        <param>
          <type>uint16_t</type>
          <declname>size</declname>
        </param>
        <briefdescription>
<para>The function configures the write buffer on an I2C Slave. </para>        </briefdescription>
        <detaileddescription>
<para>This is the buffer to which the master writes data to. The user needs to setup a new buffer every time (i.e. call <ref kindref="member" refid="group__group__hal__i2c_1ga2642bdcfecb06786c438801bbc6ed844">cyhal_i2c_slave_config_write_buffer</ref> and <ref kindref="member" refid="group__group__hal__i2c_1ga1f1570c650c1ddd12a8ffb6081dd56bb">cyhal_i2c_slave_config_read_buffer</ref> every time the buffer has been used up)<linebreak />
 See related code example: <ulink url="https://github.com/cypresssemiconductorco/mtb-example-psoc6-i2c-master">PSoC 6 MCU: I2C Master</ulink></para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2C object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">data</parametername>
</parameternamelist>
<parameterdescription>
<para>I2C slave send data </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">size</parametername>
</parameternamelist>
<parameterdescription>
<para>I2C slave send data size</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the slave_config_write_buffer request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="402" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_i2c.c" bodystart="395" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2c.h" line="263" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2c_1ga1f1570c650c1ddd12a8ffb6081dd56bb" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_i2c_slave_config_read_buffer</definition>
        <argsstring>(cyhal_i2c_t *obj, uint8_t *data, uint16_t size)</argsstring>
        <name>cyhal_i2c_slave_config_read_buffer</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2c__t">cyhal_i2c_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>uint8_t *</type>
          <declname>data</declname>
        </param>
        <param>
          <type>uint16_t</type>
          <declname>size</declname>
        </param>
        <briefdescription>
<para>The function configures the read buffer on an I2C Slave. </para>        </briefdescription>
        <detaileddescription>
<para>This is the buffer from which the master reads data from. The user needs to setup a new buffer every time (i.e. call <ref kindref="member" refid="group__group__hal__i2c_1ga2642bdcfecb06786c438801bbc6ed844">cyhal_i2c_slave_config_write_buffer</ref> and <ref kindref="member" refid="group__group__hal__i2c_1ga1f1570c650c1ddd12a8ffb6081dd56bb">cyhal_i2c_slave_config_read_buffer</ref> every time the buffer has been used up)<linebreak />
 See related code example: <ulink url="https://github.com/cypresssemiconductorco/mtb-example-psoc6-i2c-master">PSoC 6 MCU: I2C Master</ulink></para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2C object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">data</parametername>
</parameternamelist>
<parameterdescription>
<para>I2C slave receive data </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">size</parametername>
</parameternamelist>
<parameterdescription>
<para>I2C slave receive data size</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the slave_config_read_buffer request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="411" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_i2c.c" bodystart="404" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2c.h" line="277" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2c_1gac9d0f4633fe8e121b93540d2415e4dd2" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_i2c_master_mem_write</definition>
        <argsstring>(cyhal_i2c_t *obj, uint16_t address, uint16_t mem_addr, uint16_t mem_addr_size, const uint8_t *data, uint16_t size, uint32_t timeout)</argsstring>
        <name>cyhal_i2c_master_mem_write</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2c__t">cyhal_i2c_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>uint16_t</type>
          <declname>address</declname>
        </param>
        <param>
          <type>uint16_t</type>
          <declname>mem_addr</declname>
        </param>
        <param>
          <type>uint16_t</type>
          <declname>mem_addr_size</declname>
        </param>
        <param>
          <type>const uint8_t *</type>
          <declname>data</declname>
        </param>
        <param>
          <type>uint16_t</type>
          <declname>size</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>timeout</declname>
        </param>
        <briefdescription>
<para>Perform an I2C write using a block of data stored at the specified memory location. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2C object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">address</parametername>
</parameternamelist>
<parameterdescription>
<para>device address (7-bit) </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">mem_addr</parametername>
</parameternamelist>
<parameterdescription>
<para>mem address to store the written data </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">mem_addr_size</parametername>
</parameternamelist>
<parameterdescription>
<para>number of bytes in the mem address </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">data</parametername>
</parameternamelist>
<parameterdescription>
<para>I2C master send data </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">size</parametername>
</parameternamelist>
<parameterdescription>
<para>I2C master send data size </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">timeout</parametername>
</parameternamelist>
<parameterdescription>
<para>timeout in millisecond, set this value to 0 if you want to wait forever </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the write request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="452" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_i2c.c" bodystart="413" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2c.h" line="292" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2c_1ga3b3c9ae9cd2a99bfb7fcd513c00a50bd" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_i2c_master_mem_read</definition>
        <argsstring>(cyhal_i2c_t *obj, uint16_t address, uint16_t mem_addr, uint16_t mem_addr_size, uint8_t *data, uint16_t size, uint32_t timeout)</argsstring>
        <name>cyhal_i2c_master_mem_read</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2c__t">cyhal_i2c_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>uint16_t</type>
          <declname>address</declname>
        </param>
        <param>
          <type>uint16_t</type>
          <declname>mem_addr</declname>
        </param>
        <param>
          <type>uint16_t</type>
          <declname>mem_addr_size</declname>
        </param>
        <param>
          <type>uint8_t *</type>
          <declname>data</declname>
        </param>
        <param>
          <type>uint16_t</type>
          <declname>size</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>timeout</declname>
        </param>
        <briefdescription>
<para>Perform an I2C read using a block of data stored at the specified memory location. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2C object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">address</parametername>
</parameternamelist>
<parameterdescription>
<para>device address (7-bit) </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">mem_addr</parametername>
</parameternamelist>
<parameterdescription>
<para>mem address to store the written data </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">mem_addr_size</parametername>
</parameternamelist>
<parameterdescription>
<para>number of bytes in the mem address </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">data</parametername>
</parameternamelist>
<parameterdescription>
<para>I2C master send data </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">size</parametername>
</parameternamelist>
<parameterdescription>
<para>I2C master send data size </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">timeout</parametername>
</parameternamelist>
<parameterdescription>
<para>timeout in millisecond, set this value to 0 if you want to wait forever </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the read request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="480" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_i2c.c" bodystart="454" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2c.h" line="305" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2c_1gad6cd59cead5f7de0cf87571ceb656054" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_i2c_master_transfer_async</definition>
        <argsstring>(cyhal_i2c_t *obj, uint16_t address, const void *tx, size_t tx_size, void *rx, size_t rx_size)</argsstring>
        <name>cyhal_i2c_master_transfer_async</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2c__t">cyhal_i2c_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>uint16_t</type>
          <declname>address</declname>
        </param>
        <param>
          <type>const void *</type>
          <declname>tx</declname>
        </param>
        <param>
          <type>size_t</type>
          <declname>tx_size</declname>
        </param>
        <param>
          <type>void *</type>
          <declname>rx</declname>
        </param>
        <param>
          <type>size_t</type>
          <declname>rx_size</declname>
        </param>
        <briefdescription>
<para>Initiate a non-blocking I2C master asynchronous transfer. </para>        </briefdescription>
        <detaileddescription>
<para>Supports simultaneous write and read operation.<linebreak />
</para><para>This will transfer rx_size bytes into the buffer pointed to by rx, while simultaneously transfering tx_size bytes of data from the buffer pointed to by tx, both in the background. When the requested quantity of data has been received, the <ref kindref="member" refid="group__group__hal__i2c_1ggaaba7daccaa3861c32a4b0284e8194a79ac5b8050af1c08b0d00a21539c5286435">CYHAL_I2C_MASTER_RD_CMPLT_EVENT</ref> will be raised. When the requested quantity of data has been transmitted, the <ref kindref="member" refid="group__group__hal__i2c_1ggaaba7daccaa3861c32a4b0284e8194a79a0365270204869bfe80a2015258c979e1">CYHAL_I2C_MASTER_WR_CMPLT_EVENT</ref> will be raised. See <ref kindref="member" refid="group__group__hal__i2c_1gacf738716af52c484873e35331b9a30b7">cyhal_i2c_register_callback</ref> and <ref kindref="member" refid="group__group__hal__i2c_1ga6216658331d13dd8a854a23e96141fc7">cyhal_i2c_enable_event</ref>. If either of <bold>tx_size</bold> or <bold>rx_size</bold> is '0', the respective write or read operation is not performed. See <ref kindref="member" refid="group__group__hal__i2c_1subsection_i2c_snippet_3">Snippet 3: I2C Master Asynchronous Transfer</ref></para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2C object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">address</parametername>
</parameternamelist>
<parameterdescription>
<para>device address (7-bit) </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">tx</parametername>
</parameternamelist>
<parameterdescription>
<para>The transmit buffer </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">tx_size</parametername>
</parameternamelist>
<parameterdescription>
<para>The number of bytes to transmit. Use '0' if write operation is not required. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">rx</parametername>
</parameternamelist>
<parameterdescription>
<para>The receive buffer </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">rx_size</parametername>
</parameternamelist>
<parameterdescription>
<para>The number of bytes to receive. Use '0' if read operation is not required. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the master_transfer_async request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="522" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_i2c.c" bodystart="482" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2c.h" line="326" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2c_1ga5ee41d9e5c6dc83376291ff5275c942a" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_i2c_abort_async</definition>
        <argsstring>(cyhal_i2c_t *obj)</argsstring>
        <name>cyhal_i2c_abort_async</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2c__t">cyhal_i2c_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Abort asynchronous transfer. </para>        </briefdescription>
        <detaileddescription>
<para><linebreak />
 This function aborts the ongoing transfer by generating a stop condition.<linebreak />
 See <ref kindref="member" refid="group__group__hal__i2c_1subsection_i2c_snippet_3">Snippet 3: I2C Master Asynchronous Transfer</ref></para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2C object </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the abort_async request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="538" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_i2c.c" bodystart="524" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2c.h" line="337" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2c_1gacf738716af52c484873e35331b9a30b7" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_i2c_register_callback</definition>
        <argsstring>(cyhal_i2c_t *obj, cyhal_i2c_event_callback_t callback, void *callback_arg)</argsstring>
        <name>cyhal_i2c_register_callback</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2c__t">cyhal_i2c_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__i2c_1ga67df812388aae9fcc3b3b1986dab7a09">cyhal_i2c_event_callback_t</ref></type>
          <declname>callback</declname>
        </param>
        <param>
          <type>void *</type>
          <declname>callback_arg</declname>
        </param>
        <briefdescription>
<para>Register an I2C event callback handler<linebreak />
 </para>        </briefdescription>
        <detaileddescription>
<para>This function will be called when one of the events enabled by <ref kindref="member" refid="group__group__hal__i2c_1ga6216658331d13dd8a854a23e96141fc7">cyhal_i2c_enable_event</ref> occurs.</para><para>See <ref kindref="member" refid="group__group__hal__i2c_1subsection_i2c_snippet_2">Snippet 2: Handling events</ref></para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2C object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">callback</parametername>
</parameternamelist>
<parameterdescription>
<para>The callback handler which will be invoked when an event triggers </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">callback_arg</parametername>
</parameternamelist>
<parameterdescription>
<para>Generic argument that will be provided to the callback when called </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="549" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_i2c.c" bodystart="540" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2c.h" line="350" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2c_1ga6216658331d13dd8a854a23e96141fc7" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_i2c_enable_event</definition>
        <argsstring>(cyhal_i2c_t *obj, cyhal_i2c_event_t event, uint8_t intr_priority, bool enable)</argsstring>
        <name>cyhal_i2c_enable_event</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2c__t">cyhal_i2c_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__i2c_1gaaba7daccaa3861c32a4b0284e8194a79">cyhal_i2c_event_t</ref></type>
          <declname>event</declname>
        </param>
        <param>
          <type>uint8_t</type>
          <declname>intr_priority</declname>
        </param>
        <param>
          <type>bool</type>
          <declname>enable</declname>
        </param>
        <briefdescription>
<para>Configure and Enable or Disable I2C Interrupt. </para>        </briefdescription>
        <detaileddescription>
<para>When an enabled event occurs, the function specified by <ref kindref="member" refid="group__group__hal__i2c_1gacf738716af52c484873e35331b9a30b7">cyhal_i2c_register_callback</ref> will be called.</para><para>See <ref kindref="member" refid="group__group__hal__i2c_1subsection_i2c_snippet_2">Snippet 2: Handling events</ref></para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2C object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">event</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2C event type </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">intr_priority</parametername>
</parameternamelist>
<parameterdescription>
<para>The priority for NVIC interrupt events </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">enable</parametername>
</parameternamelist>
<parameterdescription>
<para>True to turn on interrupts, False to turn off </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="564" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_i2c.c" bodystart="551" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2c.h" line="363" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="define">
      <memberdef id="group__group__hal__i2c_1gad2ea1e12f91892dfd0d6695b11f1d4a5" kind="define" prot="public" static="no">
        <name>CYHAL_I2C_MODE_SLAVE</name>
        <initializer>(true)</initializer>
        <briefdescription>
<para>Named define for Slave mode for use when initializing the <ref kindref="compound" refid="structcyhal__i2c__cfg__t">cyhal_i2c_cfg_t</ref> structure. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2c.h" bodystart="131" column="9" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2c.h" line="131" />
      </memberdef>
      <memberdef id="group__group__hal__i2c_1gae8ce31deae8ac6078af98b52249e0089" kind="define" prot="public" static="no">
        <name>CYHAL_I2C_MODE_MASTER</name>
        <initializer>(false)</initializer>
        <briefdescription>
<para>Named define for Master mode for use when initializing the <ref kindref="compound" refid="structcyhal__i2c__cfg__t">cyhal_i2c_cfg_t</ref> structure. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2c.h" bodystart="133" column="9" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2c.h" line="133" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para><linebreak />
</para><para>High level interface for interacting with the I2C resource. </para>    </briefdescription>
    <detaileddescription>
<para>The I2C protocol is a synchronous serial interface protocol. This driver supports both master and slave mode of operation. The communication frequency and address (for slave operation) can be configured.</para>
<para><heading level="1">Features</heading></para>
<para><itemizedlist>
<listitem><para>Master or slave functionality</para></listitem><listitem><para>Configurable slave address</para></listitem><listitem><para>Configurable data rates</para></listitem><listitem><para>Configurable interrupt and callback assignment from I2C events - <ref kindref="member" refid="group__group__hal__i2c_1gaaba7daccaa3861c32a4b0284e8194a79">cyhal_i2c_event_t</ref></para></listitem></itemizedlist>
</para>

<para><heading level="1">Quick Start</heading></para>
<para>Initialize an I2C instance using the <ref kindref="member" refid="group__group__hal__i2c_1gac2885a21905af9d1d48aae34a6032a61">cyhal_i2c_init</ref> and provide <bold>sda</bold> (I2C data) and <bold>scl</bold> (I2C clock) pins.<linebreak />
 By default, this initializes the resource as an I2C master.<linebreak />
 Configure the behavior (master/slave) and the interface (bus frequency, slave address) using the <ref kindref="member" refid="group__group__hal__i2c_1ga37a35abcb9bf2d0ecf2a52b2fa5bce64">cyhal_i2c_configure</ref> function. <linebreak />
 See <ref kindref="member" refid="group__group__hal__i2c_1subsection_i2c_snippet_1">Snippet 1: I2C Initialization and Configuration</ref> for example initialization as master or slave. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The clock parameter (const cyhal_clock_divider_t *clk) is optional and can be set to NULL to generate and use an available clock resource with a default frequency (CYHAL_I2C_MASTER_DEFAULT_FREQ).&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>

<para><heading level="1">Code Snippets</heading></para>

<para><bold>Snippet 1: I2C Initialization and Configuration</bold></para>
<para>This snippet initializes an I2C resource as master or slave and assigns the <bold>sda</bold> and <bold>scl</bold> pins.</para><para>Initializing as I2C master <programlisting filename="i2c.c"><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Declare<sp />variables<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />rslt;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__i2c__t">cyhal_i2c_t</ref><sp />i2c_master_obj;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Define<sp />frequency<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />I2C_MASTER_FREQUENCY<sp />=<sp />100000u;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Define<sp />the<sp />I2C<sp />master<sp />configuration<sp />structure<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__i2c__cfg__t">cyhal_i2c_cfg_t</ref><sp />i2c_master_config<sp />=<sp />{<ref kindref="member" refid="group__group__hal__i2c_1gae8ce31deae8ac6078af98b52249e0089">CYHAL_I2C_MODE_MASTER</ref>,<sp />0<sp /></highlight><highlight class="comment">/*<sp />address<sp />is<sp />not<sp />used<sp />for<sp />master<sp />mode<sp />*/</highlight><highlight class="normal">,<sp />I2C_MASTER_FREQUENCY};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />I2C<sp />master,<sp />set<sp />the<sp />SDA<sp />and<sp />SCL<sp />pins<sp />and<sp />assign<sp />a<sp />new<sp />clock<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__i2c_1gac2885a21905af9d1d48aae34a6032a61">cyhal_i2c_init</ref>(&amp;i2c_master_obj,<sp />CYBSP_I2C_SDA,<sp />CYBSP_I2C_SCL<sp />,<sp />NULL);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configure<sp />the<sp />I2C<sp />resource<sp />to<sp />be<sp />master<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__i2c_1ga37a35abcb9bf2d0ecf2a52b2fa5bce64">cyhal_i2c_configure</ref>(&amp;i2c_master_obj,<sp />&amp;i2c_master_config);</highlight></codeline>
</programlisting> Initializing as I2C slave <programlisting filename="i2c.c"><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Declare<sp />variables<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />rslt;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__i2c__t">cyhal_i2c_t</ref><sp />i2c_slave_obj;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Define<sp />address<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint16_t<sp />I2C_SLAVE_ADDRESS<sp />=<sp />0x08u;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Define<sp />frequency<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />I2C_SLAVE_FREQUENCY<sp />=<sp />100000u;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Define<sp />the<sp />slave<sp />configuration<sp />structure<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__i2c__cfg__t">cyhal_i2c_cfg_t</ref><sp />i2c_slave_config<sp />=<sp />{<ref kindref="member" refid="group__group__hal__i2c_1gad2ea1e12f91892dfd0d6695b11f1d4a5">CYHAL_I2C_MODE_SLAVE</ref>,<sp />I2C_SLAVE_ADDRESS,<sp />I2C_SLAVE_FREQUENCY};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />I2C<sp />slave,<sp />set<sp />the<sp />SDA<sp />and<sp />SCL<sp />pins<sp />and<sp />assign<sp />a<sp />new<sp />clock<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__i2c_1gac2885a21905af9d1d48aae34a6032a61">cyhal_i2c_init</ref>(&amp;i2c_slave_obj,<sp />CYBSP_I2C_SDA,<sp />CYBSP_I2C_SCL,<sp />NULL);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configure<sp />the<sp />I2C<sp />resource<sp />to<sp />be<sp />slave<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__i2c_1ga37a35abcb9bf2d0ecf2a52b2fa5bce64">cyhal_i2c_configure</ref>(&amp;i2c_slave_obj,<sp />&amp;i2c_slave_config);</highlight></codeline>
</programlisting> </para>

<para><bold>Snippet 2: Handling events</bold></para>
<para>This snippet shows how to enable and handle I2C events using <ref kindref="member" refid="group__group__hal__i2c_1ga6216658331d13dd8a854a23e96141fc7">cyhal_i2c_enable_event</ref> and <ref kindref="member" refid="group__group__hal__i2c_1gacf738716af52c484873e35331b9a30b7">cyhal_i2c_register_callback</ref>.<linebreak />
 The <bold>callback</bold> parameter of <ref kindref="member" refid="group__group__hal__i2c_1gacf738716af52c484873e35331b9a30b7">cyhal_i2c_register_callback</ref> is used to pass the callback handler that will be invoked when an event occurs.<linebreak />
 The <bold>event</bold> parameter of <ref kindref="member" refid="group__group__hal__i2c_1ga6216658331d13dd8a854a23e96141fc7">cyhal_i2c_enable_event</ref> is used to pass the bitmasks of events ( <ref kindref="member" refid="group__group__hal__i2c_1gaaba7daccaa3861c32a4b0284e8194a79">cyhal_i2c_event_t</ref>) to be enabled.</para><para><programlisting filename="i2c.c"><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />handle_i2c_events(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*callback_arg,<sp /><ref kindref="member" refid="group__group__hal__i2c_1gaaba7daccaa3861c32a4b0284e8194a79">cyhal_i2c_event_t</ref><sp />event)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />To<sp />remove<sp />unused<sp />variable<sp />warning<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(void)<sp />callback_arg;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Check<sp />write<sp />complete<sp />event<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(0UL<sp />!=<sp />(<ref kindref="member" refid="group__group__hal__i2c_1ggaaba7daccaa3861c32a4b0284e8194a79aed43708fe51a3270699f80f21dde4bac">CYHAL_I2C_SLAVE_WR_CMPLT_EVENT</ref><sp />&amp;<sp />event))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Perform<sp />the<sp />required<sp />functions<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Check<sp />read<sp />complete<sp />event<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(0UL<sp />!=<sp />(<ref kindref="member" refid="group__group__hal__i2c_1ggaaba7daccaa3861c32a4b0284e8194a79af3743e0bae6fc016ae15741d69b765e8">CYHAL_I2C_SLAVE_RD_CMPLT_EVENT</ref><sp />&amp;<sp />event))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Perform<sp />the<sp />required<sp />functions<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Check<sp />for<sp />errors<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(0UL<sp />==<sp />(<ref kindref="member" refid="group__group__hal__i2c_1ggaaba7daccaa3861c32a4b0284e8194a79aba7cb8e07c8f47bd41a74af1373c7d04">CYHAL_I2C_SLAVE_ERR_EVENT</ref><sp />&amp;<sp />event))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Perform<sp />the<sp />required<sp />function<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />snippet_cyhal_i2c_slave_callback_init()</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Declare<sp />variables<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />rslt;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__i2c__t">cyhal_i2c_t</ref><sp />i2c_slave_obj;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Define<sp />the<sp />slave<sp />configuration<sp />structure<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__i2c__cfg__t">cyhal_i2c_cfg_t</ref><sp />i2c_slave_config<sp />=<sp />{<ref kindref="member" refid="group__group__hal__i2c_1gad2ea1e12f91892dfd0d6695b11f1d4a5">CYHAL_I2C_MODE_SLAVE</ref>,<sp />0x08u,<sp />100000u<sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />I2C<sp />slave,<sp />set<sp />the<sp />SDA<sp />and<sp />SCL<sp />pins<sp />and<sp />assign<sp />a<sp />new<sp />clock<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__i2c_1gac2885a21905af9d1d48aae34a6032a61">cyhal_i2c_init</ref>(&amp;i2c_slave_obj,<sp />CYBSP_I2C_SDA,<sp />CYBSP_I2C_SCL,<sp />NULL);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />rslt);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configure<sp />the<sp />I2C<sp />resource<sp />to<sp />be<sp />slave<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__i2c_1ga37a35abcb9bf2d0ecf2a52b2fa5bce64">cyhal_i2c_configure</ref>(&amp;i2c_slave_obj,<sp />&amp;i2c_slave_config);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />rslt);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Register<sp />I2C<sp />slave<sp />event<sp />callback<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__i2c_1gacf738716af52c484873e35331b9a30b7">cyhal_i2c_register_callback</ref>(&amp;i2c_slave_obj,<sp />(<ref kindref="member" refid="group__group__hal__i2c_1ga67df812388aae9fcc3b3b1986dab7a09">cyhal_i2c_event_callback_t</ref>)<sp />handle_i2c_events,<sp />NULL);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Enable<sp />I2C<sp />Events<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__i2c_1ga6216658331d13dd8a854a23e96141fc7">cyhal_i2c_enable_event</ref>(&amp;i2c_slave_obj,<sp />(<ref kindref="member" refid="group__group__hal__i2c_1gaaba7daccaa3861c32a4b0284e8194a79">cyhal_i2c_event_t</ref>)<sp /><sp /><sp />\</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(<ref kindref="member" refid="group__group__hal__i2c_1ggaaba7daccaa3861c32a4b0284e8194a79aed43708fe51a3270699f80f21dde4bac">CYHAL_I2C_SLAVE_WR_CMPLT_EVENT</ref><sp />\</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />|<sp /><ref kindref="member" refid="group__group__hal__i2c_1ggaaba7daccaa3861c32a4b0284e8194a79af3743e0bae6fc016ae15741d69b765e8">CYHAL_I2C_SLAVE_RD_CMPLT_EVENT</ref><sp />\</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />|<sp /><ref kindref="member" refid="group__group__hal__i2c_1ggaaba7daccaa3861c32a4b0284e8194a79aba7cb8e07c8f47bd41a74af1373c7d04">CYHAL_I2C_SLAVE_ERR_EVENT</ref>),<sp /><sp /><sp /><sp />\</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />3u<sp />,<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
</programlisting> </para>

<para><bold>Snippet 3: I2C Master Asynchronous Transfer</bold></para>
<para>This snippet shows how to implement asynchronous transfers using <ref kindref="member" refid="group__group__hal__i2c_1gad6cd59cead5f7de0cf87571ceb656054">cyhal_i2c_master_transfer_async</ref>.<linebreak />
 <ref kindref="member" refid="group__group__hal__i2c_1ga5ee41d9e5c6dc83376291ff5275c942a">cyhal_i2c_abort_async</ref> is used to stop the transfer, in this case when an error occurs.</para><para><programlisting filename="i2c.c"><codeline><highlight class="comment">/*<sp />Declare<sp />variables<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="compound" refid="structcyhal__i2c__t">cyhal_i2c_t</ref><sp />i2c_master_obj;</highlight></codeline>
<codeline><highlight class="normal">uint8_t<sp />tx_buff[3]<sp />=<sp />{1,<sp />2,<sp />3};</highlight></codeline>
<codeline><highlight class="normal">uint8_t<sp />rx_buff[3];</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Defining<sp />master<sp />callback<sp />handler<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />master_event_handler(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*callback_arg,<sp /><ref kindref="member" refid="group__group__hal__i2c_1gaaba7daccaa3861c32a4b0284e8194a79">cyhal_i2c_event_t</ref><sp />event)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />To<sp />remove<sp />unused<sp />variable<sp />warning<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(void)<sp />callback_arg;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Check<sp />write<sp />complete<sp />event<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(0UL<sp />!=<sp />(<ref kindref="member" refid="group__group__hal__i2c_1ggaaba7daccaa3861c32a4b0284e8194a79aed43708fe51a3270699f80f21dde4bac">CYHAL_I2C_SLAVE_WR_CMPLT_EVENT</ref><sp />&amp;<sp />event))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Perform<sp />the<sp />required<sp />functions<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Check<sp />read<sp />complete<sp />event<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(0UL<sp />!=<sp />(<ref kindref="member" refid="group__group__hal__i2c_1ggaaba7daccaa3861c32a4b0284e8194a79af3743e0bae6fc016ae15741d69b765e8">CYHAL_I2C_SLAVE_RD_CMPLT_EVENT</ref><sp />&amp;<sp />event))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Perform<sp />the<sp />required<sp />functions<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(0UL<sp />!=<sp />(<ref kindref="member" refid="group__group__hal__i2c_1ggaaba7daccaa3861c32a4b0284e8194a79aba7cb8e07c8f47bd41a74af1373c7d04">CYHAL_I2C_SLAVE_ERR_EVENT</ref><sp />&amp;<sp />event))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />In<sp />case<sp />of<sp />error<sp />abort<sp />transfer<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__i2c_1ga5ee41d9e5c6dc83376291ff5275c942a">cyhal_i2c_abort_async</ref>(&amp;i2c_master_obj);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />snippet_cyhal_async_transfer(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />rslt;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Define<sp />address<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint16_t<sp />I2C_SLAVE_ADDRESS<sp />=<sp />0x08u;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Define<sp />frequency<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />I2C_MASTER_FREQUENCY<sp />=<sp />100000u;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configure<sp />I2C<sp />Master<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__i2c__cfg__t">cyhal_i2c_cfg_t</ref><sp />i2c_master_config<sp />=<sp />{<ref kindref="member" refid="group__group__hal__i2c_1gae8ce31deae8ac6078af98b52249e0089">CYHAL_I2C_MODE_MASTER</ref>,<sp />0,<sp />I2C_MASTER_FREQUENCY};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__i2c_1gac2885a21905af9d1d48aae34a6032a61">cyhal_i2c_init</ref>(&amp;i2c_master_obj,<sp />CYBSP_I2C_SDA,<sp />CYBSP_I2C_SCL,<sp />NULL);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />rslt);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__i2c_1ga37a35abcb9bf2d0ecf2a52b2fa5bce64">cyhal_i2c_configure</ref>(&amp;i2c_master_obj,<sp />&amp;i2c_master_config);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />rslt);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__i2c_1gacf738716af52c484873e35331b9a30b7">cyhal_i2c_register_callback</ref>(&amp;i2c_master_obj,<sp />(<ref kindref="member" refid="group__group__hal__i2c_1ga67df812388aae9fcc3b3b1986dab7a09">cyhal_i2c_event_callback_t</ref>)<sp />master_event_handler,<sp />NULL);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__i2c_1ga6216658331d13dd8a854a23e96141fc7">cyhal_i2c_enable_event</ref>(&amp;i2c_master_obj,<sp />(<ref kindref="member" refid="group__group__hal__i2c_1gaaba7daccaa3861c32a4b0284e8194a79">cyhal_i2c_event_t</ref>)<sp /><sp /><sp />\</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(<ref kindref="member" refid="group__group__hal__i2c_1ggaaba7daccaa3861c32a4b0284e8194a79aed43708fe51a3270699f80f21dde4bac">CYHAL_I2C_SLAVE_WR_CMPLT_EVENT</ref><sp />\</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />|<sp /><ref kindref="member" refid="group__group__hal__i2c_1ggaaba7daccaa3861c32a4b0284e8194a79af3743e0bae6fc016ae15741d69b765e8">CYHAL_I2C_SLAVE_RD_CMPLT_EVENT</ref><sp />\</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />|<sp /><ref kindref="member" refid="group__group__hal__i2c_1ggaaba7daccaa3861c32a4b0284e8194a79aba7cb8e07c8f47bd41a74af1373c7d04">CYHAL_I2C_SLAVE_ERR_EVENT</ref>),<sp /><sp /><sp /><sp />\</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />3u<sp />,<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initiate<sp />master<sp />write<sp />and<sp />read<sp />transfer<sp />using<sp />tx_buff<sp />and<sp />rx_buff<sp />respectively.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__i2c_1gad6cd59cead5f7de0cf87571ceb656054">cyhal_i2c_master_transfer_async</ref>(&amp;i2c_master_obj,<sp />I2C_SLAVE_ADDRESS,<sp />tx_buff,<sp />3,<sp />rx_buff,<sp />3);</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
</programlisting> </para>


<para><heading level="1">More Information</heading></para>
<para><bold>Peripheral Driver Library (PDL)</bold><itemizedlist>
<listitem><para><ulink url="https://cypresssemiconductorco.github.io/psoc6pdl/pdl_api_reference_manual/html/group__group__scb.html"> PSoC 6 PDL: SCB (Serial Communication Block)</ulink></para></listitem></itemizedlist>
</para><para><bold>Code examples (Github)</bold><itemizedlist>
<listitem><para><ulink url="https://github.com/cypresssemiconductorco/mtb-example-psoc6-i2c-master"> PSoC 6 MCU: I2C Master</ulink></para></listitem><listitem><para><ulink url="https://github.com/cypresssemiconductorco/mtb-example-psoc6-i2c-slave-callback"> PSoC 6 MCU: I2C Slave Using Callbacks</ulink> </para></listitem></itemizedlist>
</para>
    </detaileddescription>
  </compounddef>
</doxygen>